﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Security;

namespace HyperV
{
    public class Credentials
    {
        private string username;
        private string domain;
        private SecureString password;

        public Credentials(string username, string domain, string password)
            : this(username, domain)
        {
            this.password = new SecureString();
            foreach (var c in password.ToCharArray())
                this.password.AppendChar(c);
            this.password.MakeReadOnly();
        }

        public Credentials(string username, string domain, SecureString password)
            : this(username, domain)
        {
            this.password = password;
            this.password.MakeReadOnly();
        }

        public Credentials(string username, string domain)
        {
            this.username = username;
            this.domain = domain;
        }

        internal string Username
        {
            get
            {
                return username;
            }
        }

        internal string Domain
        {
            get
            {
                return domain;
            }
        }

        internal SecureString Password
        {
            get
            {
                return password;
            }
        }





    }
}
