﻿using System.Linq;

namespace System.Management.HyperV.Model
{
    /// <summary>
    /// Represents a virtual computer system.
    /// </summary>
    public sealed class Guest : Msvm.ComputerSystem
    {
        #region Constructor
        internal Guest(ManagementObject wmiInstance)
            : base(wmiInstance)
        {
        }
        #endregion

        public string HostName
        {
            get
            {
                var p = this.__SERVER;
                return null;
            }
        }

        public Snapshot[] Snapshots
        {
            get
            {
                var query = new ObjectQuery(string.Format("SELECT * FROM Msvm_VirtualSystemSettingData WHERE Parent = '{0}' ", this.Name));

                using (var searcher = new ManagementObjectSearcher(this.WmiInstance.Scope, query))
                {
                    var searchResults = from mo in searcher.Get().OfType<ManagementObject>()
                                        select new Model.Snapshot(mo);

                    return searchResults.ToArray();
                }
            }
        }
    }
}
