﻿
namespace System.Management.HyperV.Model.Msvm
{
    /// <summary>
    /// Represents a physical computer system or virtual computer system (VM).
    /// </summary>
    /// <remarks>http://msdn.microsoft.com/en-us/library/cc136822(VS.85).aspx</remarks>
    public class ComputerSystem : CIM.ComputerSystem
    {
        #region Constructor
        internal protected ComputerSystem(ManagementObject wmiInstance)
            : base(wmiInstance)
        {
        }
        #endregion

        public ulong OnTimeInMilliseconds
        {
            get { return (ulong)_dmo.OnTimeInMilliseconds; }
        }
        public uint ProcessID
        {
            get { return (uint)_dmo.ProcessID; }
        }
        public string TimeOfLastConfigurationChange
        {
            get { return _dmo.TimeOfLastConfigurationChange as string; }
        }
    }
}
